typedef struct _MMX {
    long lo;
    long hi;
} MMX;

typedef struct _CONTEXT {
    long start;
    long stop;
    MMX temp0;
    MMX temp1;
    MMX temp2;
    MMX temp3;
} CONTEXT;

static CONTEXT ctx;

#define TEST(_name, _body) \
	long _name() { \
    CONTEXT *pctx = &ctx; \
	__asm__ __volatile__( \
	"rdtsc \n\t" \
	"movl %%eax , 0(%%esi) \n\t" \
	"movl $1000000 , %%ecx \n\t" \
	"pxor %%mm0, %%mm0 \n\t" \
	"pxor %%mm1, %%mm1 \n\t" \
	"pxor %%mm2, %%mm2 \n\t" \
	"pxor %%mm3, %%mm3 \n\t" \
	"pxor %%mm4, %%mm4 \n\t" \
	"pxor %%mm5, %%mm5 \n\t" \
	"pxor %%mm6, %%mm6 \n\t" \
	"pxor %%mm7, %%mm7 \n\t" \
	_body \
	"rdtsc \n\t" \
	"movl %%eax , 4(%%esi) \n\t" \
	"emms \n\t" \
	: \
	: "S" (pctx) \
	: "memory" \
	); \
	return ctx.stop-ctx.start; \
}

#define RUN(_name, _count) \
	min = 0x7fffffff; \
	for(i=0; i<_count; ++i) { \
		int curr = _name(); \
		if(curr < min) min = curr; \
	} \
	printf(#_name ": %f\n", (double)min/1000000.0)
